Subject: Re: [PATCH] IPv6: optimize echo reply checksum calculation

From: Brian Haley <[email-masked]>
Date: Fri, 10 Nov 2006 16:06:52 -0500

Al Viro wrote:
> On Fri, Nov 10, 2006 at 02:04:32PM -0500, Brian Haley wrote:
>> Al Viro wrote:
>>> so -= 1 is broken even on ia64 and it's *always* broken on big-endian
>>> boxen.
>> It's not broken in ia64, I've tested that, just don't have an x86 for 
>> testing right now.  Can you please apply these changes and prove it's 
>> broken?  This little trick has been done in other UNIXes for years 
>> without any problems.
> 
> Could you fscking read what you've replied to?  Your -=1 will turn 0
> into 0xffff instead of correct 0xfffe.  IOW, it's broken in 1:65536
> cases.

I looked again at your previous email:

> Note that even on little-endian you want
> 	3 -> 2
> 	2 -> 1
> 	1 -> 0xffff
> 	0 -> 0xfffe

That doesn't look right to me, but I'll take your word that there's one 
edge case out there I don't see (even though this worked on Alpha). 
Forget about the patch then.

-Brian